#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <aes.h>
#include <vdi.h>
#include <tos.h>
#include <math.h>
#include <time.h>

static _WORD xworkout[57];
static _WORD vdi_handle;
static _WORD phys_handle;
static _WORD gl_wchar, gl_hchar;
static GRECT screen;
static GRECT desk;
static MFDB screen_mfdb;
static int hori = 0;
static int fullscreen = 0;
static _WORD win_handle;
static GRECT work;


void screen_init(void)
{
	_WORD dummy;
	_WORD workin[11];
	_WORD workout[57];
	int i;
	_WORD pxy[4];

	phys_handle = graf_handle(&gl_wchar, &gl_hchar, &dummy, &dummy);
	wind_get(0, WF_WORKXYWH, &desk.g_x, &desk.g_y, &desk.g_w, &desk.g_h);
	wind_get(0, WF_CURRXYWH, &screen.g_x, &screen.g_y, &screen.g_w, &screen.g_h);
	
	vdi_handle = phys_handle;
	for (i = 0; i < 10; i++)
		workin[i] = 1;
	workin[10] = 2;
	v_opnvwk(workin, &vdi_handle, workout);

	vswr_mode(vdi_handle, MD_REPLACE);

	vst_color(vdi_handle, G_BLACK);
	vst_alignment(vdi_handle, 0, 5, &dummy, &dummy);
	vst_effects(vdi_handle, 0);
	vst_rotation(vdi_handle, 0);

	vsf_perimeter(vdi_handle, 0);
	vsf_interior(vdi_handle, FIS_SOLID);
	vsf_style(vdi_handle, 0);
	vsf_color(vdi_handle, G_WHITE);

	vsl_width(vdi_handle, 1);
	vsl_color(vdi_handle, G_BLACK);
	vsl_ends(vdi_handle, 0, 0);
	vsl_type(vdi_handle, LT_SOLID);
	
	vsm_height(vdi_handle, 1);
	vsm_type(vdi_handle, MRKR_DOT);

	pxy[0] = screen.g_x;
	pxy[1] = screen.g_y;
	pxy[2] = screen.g_x + screen.g_w - 1;
	pxy[3] = screen.g_y + screen.g_h - 1;
	vs_clip(vdi_handle, 0, pxy);
	
	screen_mfdb.fd_w = screen.g_w;
	screen_mfdb.fd_h = screen.g_h;
	screen_mfdb.fd_wdwidth = (screen.g_w + 15) >> 4;
	screen_mfdb.fd_nplanes = xworkout[4];
	screen_mfdb.fd_stand = 0;
	screen_mfdb.fd_addr = 0;
}
	


void screen_exit(void)
{
	if (win_handle > 0)
	{
		wind_close(win_handle);
		wind_delete(win_handle);
	}
	if (vdi_handle > 0)
	{
		v_clsvwk(vdi_handle);
		vdi_handle = 0;
	}
	if (fullscreen)
		form_dial(FMD_FINISH, screen.g_x, screen.g_y, screen.g_w, screen.g_h, screen.g_x, screen.g_y, screen.g_w, screen.g_h);
}


/*
for each pixel (Px, Py) on the screen do

    x0 := scaled x coordinate of pixel (scaled to lie in the Mandelbrot X scale (-2.00, 0.47))
    y0 := scaled y coordinate of pixel (scaled to lie in the Mandelbrot Y scale (-1.12, 1.12))
    x := 0.0
    y := 0.0
    iteration := 0
    max_iteration := 1000
    while (x*x + y*y ? 2*2 AND iteration < max_iteration) do
        xtemp := x*x - y*y + x0
        y := 2*x*y + y0
        x := xtemp
        iteration := iteration + 1

    color := palette[iteration]
    plot(Px, Py, color)
*/

static void mandelbrot_hori(void)
{
	_WORD breite, hoehe, tiefe;
	double xa, xe, ya, ye, dx, dy, cx, cy;
	_WORD spalte, zeile, zaehler;
	_WORD farbe;
	double realteil, zx, zy, zxx, zyy;
	_WORD pxy[2];
	
	breite = work.g_w;
	hoehe = work.g_h;
	tiefe = 100;
	xa = -2.02;
	xe = 0.7;
	ya = 1.2;
	ye = -1.2;
	dx = (xe - xa) / breite;
	dy = (ya - ye) / hoehe;
	
	for (spalte = 0; spalte < breite; spalte++)
	{
		cx = xa + spalte * dx;
		for (zeile = 0; zeile < hoehe; zeile++)
		{
			cy = ya - zeile * dy;
			zx = 0;
			zy = 0;
			zaehler = 0;
	        do
	        {
				zxx = zx * zx;
				zyy = zy * zy;
				realteil = zxx - zyy + cx;
				zy = (zx + zx) * zy + cy;   /* Imaginaerteil) */
				zx = realteil;
				zaehler = zaehler + 1;
	        } while ((zxx + zyy) <= 4.0 && zaehler != tiefe);
			if (zaehler >= tiefe)
			{
				farbe = G_BLACK;
			} else
			{
				farbe = zaehler & 15; /* Farbnummern von 1 bis 15 */
	        }
	        vsm_color(vdi_handle, farbe);
	        pxy[0] = spalte;
	        pxy[1] = zeile;
	        v_pmarker(vdi_handle, 1, pxy);
		}
		if (Cconis())
		{
			(void) Cnecin();
			break;
		}
	}
}


static void mandelbrot_vert(void)
{
	_WORD breite, hoehe, tiefe;
	double xa, xe, ya, ye, dx, dy, cx, cy;
	_WORD spalte, zeile, zaehler;
	_WORD farbe;
	double realteil, zx, zy, zxx, zyy;
	_WORD pxy[2];
	
	breite = work.g_w;
	hoehe = work.g_h;
	tiefe = 100;
	xa = -2.02;
	xe = 0.7;
	ya = 1.2;
	ye = -1.2;
	dx = (xe - xa) / breite;
	dy = (ya - ye) / hoehe;
	
	for (zeile = 0; zeile < hoehe; zeile++)
	{
		cy = ya - zeile * dy;
		for (spalte = 0; spalte < breite; spalte++)
		{
			cx = xa + spalte * dx;
			zx = 0;
			zy = 0;
			zaehler = 0;
	        do
	        {
				zxx = zx * zx;
				zyy = zy * zy;
				realteil = zxx - zyy + cx;
				zy = (zx + zx) * zy + cy;   /* Imaginaerteil) */
				zx = realteil;
				zaehler = zaehler + 1;
	        } while ((zxx + zyy) <= 4.0 && zaehler != tiefe);
			if (zaehler >= tiefe)
			{
				farbe = G_BLACK;
			} else
			{
				farbe = zaehler & 15; /* Farbnummern von 1 bis 15 */
	        }
	        vsm_color(vdi_handle, farbe);
	        pxy[0] = spalte + work.g_x;
	        pxy[1] = zeile + work.g_y;
	        v_pmarker(vdi_handle, 1, pxy);
		}
		if (Cconis())
		{
			(void) Cnecin();
			break;
		}
	}
}


static void event_loop(void)
{
	_WORD events;
	_WORD msg[8];
	int done = 0;
	_WORD dummy;
	clock_t start, end;
	double duration;
	char buf[100];
	_WORD pxy[4];


	do
	{
		events = evnt_multi(MU_MESAG | MU_KEYBD,
			0, 0, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			msg,
			0,
			&dummy, &dummy, &dummy, &dummy, &dummy, &dummy);
		
		if (events & MU_MESAG)
		{
			switch (msg[0])
			{
			case WM_MOVED:
				wind_set_grect(msg[3], WF_CURRXYWH, (GRECT *)&msg[4]);
				break;
			case WM_CLOSED:
				done = TRUE;
				break;
			case WM_TOPPED:
				wind_set_int(msg[3], WF_TOP, 0);
				break;
			case WM_REDRAW:
				wind_update(BEG_UPDATE);
				wind_update(BEG_MCTRL);

				wind_get_grect(win_handle, WF_WORKXYWH, &work);
				pxy[0] = work.g_x;
				pxy[1] = work.g_y;
				pxy[2] = work.g_x + work.g_w - 1;
				pxy[3] = work.g_y + work.g_h - 1;
				vswr_mode(vdi_handle, MD_REPLACE);
				v_hide_c(vdi_handle);
				vs_clip(vdi_handle, TRUE, pxy);
				vr_recfl(vdi_handle, pxy);
			
				start = clock();
				if (hori)
					mandelbrot_hori();
				else
					mandelbrot_vert();
				end = clock();
				duration = ((double)(end - start) / CLOCKS_PER_SEC);
				
				vswr_mode(vdi_handle, MD_TRANS);
				sprintf(buf, "Duration: %.3f seconds", duration);
				v_gtext(vdi_handle, work.g_x, work.g_y, buf);
					
				v_show_c(vdi_handle, 0);
				wind_update(END_MCTRL);
				wind_update(END_UPDATE);
				break;
			}
		}
		
		if (events & MU_KEYBD)
		{
			done = TRUE;
		}
	} while (!done);
}


int main(void)
{
	clock_t start, end;
	double duration;
	char buf[100];
	
	appl_init();
	screen_init();

	graf_mouse(ARROW, NULL);

	
	if (fullscreen)
	{
		_WORD pxy[4];

		pxy[0] = screen.g_x;
		pxy[1] = screen.g_y;
		pxy[2] = screen.g_x + screen.g_w - 1;
		pxy[3] = screen.g_y + screen.g_h - 1;

		wind_update(BEG_UPDATE);
		wind_update(BEG_MCTRL);
		vswr_mode(vdi_handle, MD_REPLACE);
		v_hide_c(vdi_handle);
		vr_recfl(vdi_handle, pxy);
	
		work = screen;
		start = clock();
		if (hori)
			mandelbrot_hori();
		else
			mandelbrot_vert();
		end = clock();
		duration = ((double)(end - start) / CLOCKS_PER_SEC);
		
		sprintf(buf, "\033Y# Duration: %.3f seconds\r\nPress any key", duration);
		(void) Cconws(buf);
		(void) Cnecin();
			
		v_show_c(vdi_handle, 0);
		wind_update(END_MCTRL);
		wind_update(END_UPDATE);
	} else
	{
		win_handle = wind_create(NAME | CLOSER | MOVER, desk.g_x, desk.g_y, desk.g_w, desk.g_h);
		if (win_handle <= 0)
		{
			form_alert(1, "[1][No more windows][Abort]");
		} else
		{
			wind_set_str(win_handle, WF_NAME, " Mandelbrot ");
			wind_open(win_handle, desk.g_x, desk.g_y, desk.g_w, desk.g_h);
			event_loop();
		}
	}
	
	screen_exit();
	
	appl_exit();
		
	return 0;
}
